#ifndef _MTIME_TIMEDELTA_TEST_H
#define _MTIME_TIMEDELTA_TEST_H

#include <check.h>
#include <stdint.h>
#include "mtime_timedelta.h"

void add_mtime_timedelta_test_to_suite(Suite* suite);

/*** SPECIAL ASSERT FUNCTIONS ***/
void assertTimeDelta(const char* input_string, bool std_form, char sign, int64_t year, int month, int day, int hour, int minute, int second, int ms, const char* expected_output_string);
void assertInvalidTimeDelta(const char* input_string);
void assertTimeDeltaToJulianDelta(const char* timedelta_string, const char* base_datetime_string, char expected_jd_sign, int64_t expected_jd_day, int64_t expected_jd_ms);
void assertTimeDeltaToJulianDeltaWithoutExpactations(const char* timedelta_string, const char* base_datetime_string, char expected_jd_sign);
void assertJulianDeltaToTimeDelta(int64_t jd_day, int64_t jd_ms, const char* base_datetime_string, const char* expected_timedelta_string);
void assertGetTimeDeltaFromDate(const char* date1_string, const char* date2_string, const char* expected_timedelta_string);
void assertGetTimeDeltaFromDateTime(const char* datetime1_string, const char* datetime2_string, const char* expected_timedelta_string);
void assertDivideTimeDeltaInSeconds(const char* timedelta_dividend_string, const char* timedelta_divisor_string, int64_t expected_quotient, int64_t expected_remainder);
void assertTotalMilliSecondsAndTotalSeconds(const char* timedelta_string, const char* base_datetime_string, int64_t expected_milliseconds, int64_t expected_seconds);
void assertAddTimeDeltaToDate(const char* date_string, const char* timedelta_string, const char* expected_date_string);

#endif
